/***************************************************************************
                          cmessagehandler.h  -  description
                             -------------------
    begin                : Sun Sep 30 2001
    copyright            : (C) 2001-2003 by Mathias Kster
    email                : mathen@users.berlios.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CMESSAGEHANDLER_H
#define CMESSAGEHANDLER_H

/**
  *@author Mathias Kster
  */

#include <dclib/dcos.h>
#include <dclib/dcobject.h>
#include <dclib/core/cobject.h>
#include <dclib/core/cstring.h>

class CIconv;

class DLL_EXPORT CMessageHandler {
public: 
	/** */
	CMessageHandler( CString remoteEncoding = CString() );
	/** */
	virtual ~CMessageHandler();

	/** */
	eDCMessage Parse( const CString * sMessage, int & pointer, CObject ** Object );

private:
	/** */
	bool GetContent( const CString sMessage, const CString * sData, CString & sContent );

	/** */
	CObject * ParseLock( const CString & sContent );
	/** */
	CObject * ParseHello( const CString & sContent );
	/** */
	CObject * ParseMyNick( const CString & sContent );
	/** */
	CObject * ParseChat( const CString & sContent );
	/** */
	CObject * ParseMyInfo( const CString & sContent );
	/** */
	CObject * ParseNickList( const CString & sContent );
	/** */
	CObject * ParseOpList( const CString & sContent );
	/** */
	CObject * ParseConnectToMe( const CString & sContent );
	/** */
	CObject * ParseRevConnectToMe( const CString & sContent );
	/** */
	CObject * ParseQuit( const CString & sContent );
	/** */
	CObject * ParseSearch( const CString & sContent );
	/** */
	CObject * ParseSearchResult( const CString & sContent );
	/** */
	CObject * ParseSearchResultFile( const CString & sContent );
	/** */
	CObject * ParseSearchResultFolder( const CString & sContent );
	/** */
	CObject * ParsePrivateChat( const CString & sContent );
	/** */
	CObject * ParseForceMove( const CString & sContent );
	/** */
	CObject * ParseDirection( const CString & sContent );
	/** */
	CObject * ParseFileLength( const CString & sContent );
	/** */
	CObject * ParseGet( const CString & sContent );
	/** */
	CObject * ParseUGetBlock( const CString & sContent );
	/** */
	CObject * ParseUGetZBlock( const CString & sContent );
	/** */
	CObject * ParseError( const CString & sContent );
	/** */
	CObject * ParseGetInfo( const CString & sContent );
	/** */
	CObject * ParseHubName( const CString & sContent );
	/** */
	CObject * ParseLogedIn( CString sContent );
	/** */
	CObject * ParseSupports( CString sContent );
	/** */
	CObject * ParseCapabilities( CString sContent );
	/** */
	CObject * ParseHubTopic( const CString & sContent );
	/** */
	CObject * ParseUserCommand( const CString & sContent );
	/** */
	CObject * ParseYourIP( const CString & sContent );
	/** */
	CObject * ParseGetZBlock( const CString & sContent );
	/** */
	CObject * ParseSending( const CString & sContent );
	/** */
	CObject * ParseADCGet( const CString & sContent );
	/** */
	CObject * ParseADCSnd( const CString & sContent );
	/** Parse UserIP message */
	CObject * ParseUserIP( const CString & sContent );

	/** CIconv object for doing text encoding remote to local */
	CIconv * m_pRemoteToLocal;
	/** CIconv object for doing UTF-8 to local for certain commands */
	CIconv * m_pUTF8ToLocal;
};

#endif
